




--// TSLibrary_Error.e
--// Tone koda <tone.skoda@siol.net>
--// Created on 27. December 2001.
--// Windows and DOS error handling library.





--// TSLibrary include files.
include TSLibrary_Types.e
--// Standard include files.
--// include msgbox.e causes name collision with win32lib
include get.e
include misc.e





--//--//--//--//--//--//--//--//--//-- Variables and constants. --//--//--//--//--//--//--//--//--//--//--//--//--//--//--//--//--//--//--//--//--//--//--//--//--//--//--//

--// When in debug mode some additional information is shown to programmer which
--// users shouldn't see.
--// So you should set this variable in your program to false when you
--// release your program.
global BOOL Debug
Debug = true
--// Name of program which uses this library.
--// Set it in your program, you can also leave it like it is.
global STRING Application_name
Application_name = ""





--//--//--//--//--//--//--//--//--//-- Routines. --//--//--//--//--//--//--//--//--//--//--//--//--//--//--//--//--//--//--//--//--//--//--//--//--//--//--//--//--//--//--//

--/*
-- error [Created on 30. September 2001, 12:56]
-- The 'error' procedure tells to the user an error which happended in the program.
--
-- PARAMETERS
-- 'in_routine'
--    Name of the Euphoria routine in which error happened. Without braces: ().
-- 'message'
--    Message string to tell.
--*/
global procedure error (STRING message)
    --// Message shown in message box. Different in Debug versus Release mode.
    STRING built_message
    --// Title of error message box.
    STRING message_box_title
    --// User response.
    integer response
    built_message = message
    if equal (Application_name, "") = true then --// 'Application_name' is "".
        message_box_title = "Error"
    else                                        --// 'Application_name' is NOT "".
        message_box_title = Application_name & " Error"
    end if
    --// TODO: now in windows in dos console screen is shown.
    if platform () = DOS32 or platform () = WIN32 then
        puts (1, "\n" & message_box_title & ": \n" & built_message & "\n")
        if Debug = true then    --//  In debug mode.
            puts (1, "\nPress ESCAPE to abort application,\n    'D' key to debug\n    or any other key to continue.\n")
        else                    --// In release mode.
            puts (1, "\nPress ESCAPE to abort application or any other key to continue.\n")
        end if
        response = wait_key ()
        if response = 27 then                                           --// User wants to abort program.
            puts (1, "Aborting...\n")
            sleep (1)
            abort (0)
        elsif Debug = true and response = 'd' or response = 'D' then    --// In debug mode and user wants to debug program.
            --// trace (1)  --// If you have full Euphoria then use trace
            ?1/0            --// Use this if you have poublic domain of Euphoria.
        else                                                            --// User wants to continue program.
            puts (1, "Continuing...")
            sleep (1)
            puts (1, "\n")
        end if
        --// TODO:
    --// elsif platform () = WIN32 then
        --// if Debug = true then    --// In debug mode.    
        --//     response = message_box (built_message &
        --//         "\n\n" &
        --//         "Press\n" &
        --//         "  [ YES ]  to continue,\n" &
        --//         "  [ NO ] to debug, or\n" &
        --//         "  [ Cancel ]  to quit.",
        --//         message_box_title, or_all ({MB_ICONEXCLAMATION, MB_YESNOCANCEL}))
        --//     if response = IDCANCEL then --// Exit program.
        --//         --// w32Proc (xExitProcess, {0})
        --//         abort (0)
        --//     elsif response = IDNO then  --// Debug program.
        --//         --// trace (1)  --// If you have full Euphoria then use trace
        --//         ?1/0            --// Use this if you have poublic domain of Euphoria.
        --//     end if
        --// else                    --// Not in debug mode.
        --//     response = message_box (built_message & "\n\nPress Yes to continue, Cancel to abort application.", message_box_title, or_all ({MB_ICONEXCLAMATION, MB_OKCANCEL}))
        --//     if response = IDCANCEL then --// Exit program.
        --//         --// w32Proc (xExitProcess, {0})
        --//         abort (0)
        --//     end if
        --// end if
    end if
end procedure

--/*
-- assert [Created on 29. November 2001, 19:35]
-- The 'assert' procedure is similar to C's assert ().
-- If its parameter is not true error message box is displayed.
-- Use it to test for program errors.
--
-- PARAMETERS
-- 'better_be_true'
--    If it is true nothing happens.
--    If it is false then error message box is displayed.
--*/
global procedure assert (integer better_be_true)    
	if better_be_true = false then --// Program error.
        error ("ASSERT!!! Program error. Assert was called.")
	end if
end procedure

